#include <mega16.h>
#include <stdio.h>

#define FWD 0xAA
#define R 0x22
#define L 0x88
#define CW 0x99
#define CCW 0x66

#define RSPEED OCR1AL
#define LSPEED OCR1BL

#define MAX 3
#define HMAX 1

void move (unsigned char dir,unsigned char delay,unsigned char power);

unsigned char i,rdev,ldev,ip,delay,dir,power,dirl,history[MAX],hcount=0,rotpow;

void main(void)
{

	//Initializari PORT A,PORT B,PORT C si PORT D ca porturi de intrare
	/*...*/
	//Setare Timer Counter 0,1,2
	/*...*/
	//Setare pe OFF a comparatorului analogic
	/*...*/

	while (1){
		if(PINA!=255){
			rotpow=255;
			ldev=rdev=0;

			//Detectare a culorii pe directia dreapta
			if(PINA.3==0)
				rdev=1;
			if(PINA.2==0)
				rdev=2;
			if(PINA.1==0)
				rdev=3;
			if(PINA.0==0)
				rdev=4;
			//Detectare a culorii pe directia stanga
			if(PINA.4==0)
				ldev=1;
			if(PINA.5==0)
				ldev=2;
			if(PINA.6==0)
				ldev=3;
			if(PINA.7==0)
				ldev=4;
			//Decizia
			if(rdev>ldev)
				move(R,0,195+12*rdev);
			if(rdev<ldev)
				move(L,0,195+12*ldev);
			if(rdev==ldev)
				move(FWD,0,200);
		}
	else {
		//Incercare de reparare a ultimei deplasari
		for(i=0,dirl=0;i<MAX;i++) {
			if(history[i]==L)
				{dirl++;}
		}
	if(rotpow<160) {rotpow=160;}
	if(rotpow<255) {rotpow++;}
	if(dirl>HMAX)
		{move(CW,0,rotpow);}
	else
		{move(CCW,0,rotpow);}
	}
  }; //while(1)

}
void move (unsigned char dir,unsigned char delay,unsigned char power) {
	PORTC=dir;
	if(dir==L || dir==R) {
		//Salvarea directiei parcurse
		hcount=(hcount+1)%MAX;
		history[hcount]=dir;
	}
	LSPEED=RSPEED=255;//putere;
}
